; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

							ALIGN	4

; --------------------------------------------------------------------------------------------------------------------------------------

CreateBH1					PROC	USES EBX EDI ESI

							push	NULL
							push	DWord Ptr hInstance
							push	1901h
							push	esi
							push	DWord Ptr rcBH1.bottom
							push	DWord Ptr rcBH1.right
							push	DWord Ptr rcBH1.top
							push	DWord Ptr rcBH1.left
							push	WS_CHILD or WS_VISIBLE
							push	OFFSET szNullString
							push	OFFSET szBH1Class
							push	NULL
							call	CreateWindowEx

							mov		DWord Ptr hBH1,eax

							ret
CreateBH1					ENDP

; ---------------------------------------------------------------------------

BH1_DrawXorBar			PROC	USES EBX EDI ESI,dwX:DWord,dwY:DWord
						LOCAL	_hBitmap:HBITMAP
						LOCAL	_rc:RECT

						INVOKE	GetDC,hWorkspace
						mov		edi,eax

						INVOKE	GetClientRect,hBH1,ADDR _rc

						INVOKE	CreateBitmap,8,8,1,1,ADDR DotPatternBmp

						push	eax

						INVOKE	CreatePatternBrush,eax

						push	eax

						INVOKE	SetBrushOrgEx,edi,0,dwY,NULL

						push	edi
						call	SelectObject

						push	eax

						INVOKE	PatBlt,edi,0,dwY,_rc.right,SPLITTER_HEIGHT,PATINVERT

						push	edi
						call	SelectObject

						INVOKE	DeleteObject,eax

						call	DeleteObject

						INVOKE	ReleaseDC,hWorkspace,edi

						ret
BH1_DrawXorBar			ENDP

; ---------------------------------------------------------------------------

BH1_WmLButtonDown			PROC

							mov		dwDragMode,TRUE

							INVOKE	SetCapture,hBH1

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	GetCursorPos,ADDR Old_SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR Old_SplitPoint

							INVOKE	BH1_DrawXorBar,SplitPoint.x,SplitPoint.y

							ret
BH1_WmLButtonDown			ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH1_WmMouseMove				PROC

							cmp		DWord Ptr dwDragMode,0
							je		BH1_WmMouseMove_Exit

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	BH1_DrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y
							INVOKE	BH1_DrawXorBar,SplitPoint.x,SplitPoint.y

							mov		eax,DWord Ptr SplitPoint.x
							mov		DWord Ptr Old_SplitPoint.x,eax

							mov		eax,DWord Ptr SplitPoint.y
							mov		DWord Ptr Old_SplitPoint.y,eax

BH1_WmMouseMove_Exit :

							ret
BH1_WmMouseMove				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH1_WmLButtonUp				PROC
							LOCAL	_rc:RECT
							LOCAL	_dwDelta:DWord

							cmp		DWord Ptr dwDragMode,0
							je		@Exit

							INVOKE	GetClientRect,hWorkspace,ADDR _rc

							INVOKE	ReleaseCapture

							INVOKE	BH1_DrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y

							mov		eax,SplitPoint.y
							sub		eax,rcBH1.top
							mov		_dwDelta,eax

							add		rcFolders.bottom,eax
							add		rcBH1.top,eax
							add		rcEffects.top,eax
							sub		rcEffects.bottom,eax

							cmp		rcFolders.bottom,120
							jge		@Next

								mov		rcFolders.bottom,120
								mov		rcBH1.top,120
								sub		rcEffects.bottom,eax
								mov		rcEffects.top,120 + SPLITTER_HEIGHT

@Next :

							cmp		rcEffects.bottom,120
							jge		@Next1

								mov		rcEffects.bottom,120
								mov		eax,rcBH2.top
								sub		eax,120
								mov		rcEffects.top,eax
								sub		eax,SPLITTER_HEIGHT
								mov		rcBH1.top,eax
								mov		rcFolders.bottom,eax

@Next1 :

							INVOKE	MoveWindow,hBH1,rcBH1.left,rcBH1.top,rcBH1.right,rcBH1.bottom,TRUE
							INVOKE	MoveWindow,hFolders,rcFolders.left,rcFolders.top,rcFolders.right,rcFolders.bottom,TRUE
							INVOKE	MoveWindow,hEffects,rcEffects.left,rcEffects.top,rcEffects.right,rcEffects.bottom,TRUE

							mov		dwDragMode,FALSE

@Exit :

							ret
BH1_WmLButtonUp				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH1WndProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		esi,hWnd
						mov		edi,lParam
						mov		ebx,wParam
						mov		eax,uMsg

						.IF	eax == WM_LBUTTONDOWN

							push	OFFSET BH1WndProc_Exit
							jmp		BH1_WmLButtonDown

						.ELSEIF	eax == WM_MOUSEMOVE

							push	OFFSET BH1WndProc_Exit
							jmp		BH1_WmMouseMove

						.ELSEIF	eax == WM_LBUTTONUP

							push	OFFSET BH1WndProc_Exit
							jmp		BH1_WmLButtonUp

						.ELSE

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET BH1WndProc_End
							jmp		DefWindowProc							

						.ENDIF

BH1WndProc_Exit :

						xor eax,eax

BH1WndProc_End :

						ret
BH1WndProc				ENDP

; ---------------------------------------------------------------------------
