; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

							ALIGN	4

; --------------------------------------------------------------------------------------------------------------------------------------

CreateBH2					PROC	USES EBX EDI ESI

							push	NULL
							push	DWord Ptr hInstance
							push	1905h
							push	esi
							push	DWord Ptr rcBH2.bottom
							push	DWord Ptr rcBH2.right
							push	DWord Ptr rcBH2.top
							push	DWord Ptr rcBH2.left
							push	WS_CHILD or WS_VISIBLE
							push	OFFSET szNullString
							push	OFFSET szBH2Class
							push	NULL
							call	CreateWindowEx

							mov		DWord Ptr hBH2,eax

							ret
CreateBH2					ENDP

; ---------------------------------------------------------------------------

BH2_DrawXorBar			PROC	USES EBX EDI ESI,dwX:DWord,dwY:DWord
						LOCAL	_hBitmap:HBITMAP
						LOCAL	_rc:RECT

						INVOKE	GetDC,hWorkspace
						mov		edi,eax

						INVOKE	GetClientRect,hBH1,ADDR _rc

						INVOKE	CreateBitmap,8,8,1,1,ADDR DotPatternBmp

						push	eax

						INVOKE	CreatePatternBrush,eax

						push	eax

						INVOKE	SetBrushOrgEx,edi,0,dwY,NULL

						push	edi
						call	SelectObject

						push	eax

						INVOKE	PatBlt,edi,0,dwY,_rc.right,SPLITTER_HEIGHT,PATINVERT

						push	edi
						call	SelectObject

						INVOKE	DeleteObject,eax

						call	DeleteObject

						INVOKE	ReleaseDC,hWorkspace,edi

						ret
BH2_DrawXorBar			ENDP

; ---------------------------------------------------------------------------

BH2_WmLButtonDown			PROC

							mov		dwDragMode,TRUE

							INVOKE	SetCapture,hBH2

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	GetCursorPos,ADDR Old_SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR Old_SplitPoint

							INVOKE	BH2_DrawXorBar,SplitPoint.x,SplitPoint.y

							ret
BH2_WmLButtonDown			ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH2_WmMouseMove				PROC

							cmp		DWord Ptr dwDragMode,0
							je		BH2_WmMouseMove_Exit

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	BH2_DrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y
							INVOKE	BH2_DrawXorBar,SplitPoint.x,SplitPoint.y

							mov		eax,DWord Ptr SplitPoint.x
							mov		DWord Ptr Old_SplitPoint.x,eax

							mov		eax,DWord Ptr SplitPoint.y
							mov		DWord Ptr Old_SplitPoint.y,eax

BH2_WmMouseMove_Exit :

							ret
BH2_WmMouseMove				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH2_WmLButtonUp				PROC
							LOCAL	_rc:RECT
							LOCAL	_dwDelta:DWord

							cmp		DWord Ptr dwDragMode,0
							je		@Exit

							INVOKE	GetClientRect,hWorkspace,ADDR _rc

							INVOKE	ReleaseCapture

							INVOKE	BH2_DrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y

							mov		eax,SplitPoint.y
							sub		eax,rcBH2.top
							mov		_dwDelta,eax

							add		rcEffects.bottom,eax
							add		rcBH2.top,eax
							add		rcPreview.top,eax
							sub		rcPreview.bottom,eax

							cmp		rcEffects.bottom,120
							jge		@Next

								mov		edx,120
								sub		edx,rcEffects.bottom		; DELTA
								mov		rcEffects.bottom,120
								mov		eax,rcEffects.top
								add		eax,120
								mov		rcBH2.top,eax
								add		eax,SPLITTER_HEIGHT
								mov		rcPreview.top,eax
								add		rcPreview.bottom,edx

@Next :

							cmp		rcPreview.bottom,120
							jge		@Next1

								cmp		rcEffects.bottom,120
								jle		@Next2

								mov		eax,120
								sub		eax,rcPreview.bottom
								mov		_dwDelta,eax

								mov		rcPreview.bottom,120
								mov		eax,rcWorkspace.bottom
								sub		eax,120
								mov		rcPreview.top,eax
								mov		rcBH2.top,eax
								sub		rcBH2.top,SPLITTER_HEIGHT
								mov		eax,_dwDelta
								sub		rcEffects.bottom,eax
								jmp		@Next1

@Next2 :

							mov		eax,rcWorkspace.bottom
							sub		eax,(2 * 120) + (2 * SPLITTER_HEIGHT)
							mov		_dwDelta,eax
							mov		rcFolders.bottom,eax
							mov		rcBH1.top,eax
							sub		rcEffects.top,SPLITTER_HEIGHT

@Next1 :

							INVOKE	MoveWindow,hBH2,rcBH2.left,rcBH2.top,rcBH2.right,rcBH2.bottom,TRUE
							INVOKE	MoveWindow,hEffects,rcEffects.left,rcEffects.top,rcEffects.right,rcEffects.bottom,TRUE
							INVOKE	MoveWindow,hPreview,rcPreview.left,rcPreview.top,rcPreview.right,rcPreview.bottom,TRUE

							mov		dwDragMode,FALSE

@Exit :

							ret
BH2_WmLButtonUp				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BH2WndProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		esi,hWnd
						mov		edi,lParam
						mov		ebx,wParam
						mov		eax,uMsg

						.IF	eax == WM_LBUTTONDOWN

							push	OFFSET BH2WndProc_Exit
							jmp		BH2_WmLButtonDown

						.ELSEIF	eax == WM_MOUSEMOVE

							push	OFFSET BH2WndProc_Exit
							jmp		BH2_WmMouseMove

						.ELSEIF	eax == WM_LBUTTONUP

							push	OFFSET BH2WndProc_Exit
							jmp		BH2_WmLButtonUp

						.ELSE

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET BH2WndProc_End
							jmp		DefWindowProc							

						.ENDIF

BH2WndProc_Exit :

						xor eax,eax

BH2WndProc_End :

						ret
BH2WndProc				ENDP

; ---------------------------------------------------------------------------
