; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

							ALIGN	4

; --------------------------------------------------------------------------------------------------------------------------------------

CreateBV1					PROC	USES EBX EDI ESI

							push	NULL
							push	DWord Ptr hInstance
							push	1906h
							push	esi
							push	DWord Ptr rcBV1.bottom
							push	DWord Ptr rcBV1.right
							push	DWord Ptr rcBV1.top
							push	DWord Ptr rcBV1.left
							push	WS_CHILD or WS_VISIBLE
							push	OFFSET szNullString
							push	OFFSET szBV1Class
							push	NULL
							call	CreateWindowEx

							mov		DWord Ptr hBV1,eax

							ret
CreateBV1					ENDP

; ---------------------------------------------------------------------------

BV1HDrawXorBar			PROC	USES EBX EDI ESI,dwX:DWord,dwY:DWord
						LOCAL	_hBitmap:HBITMAP
						LOCAL	_rc:RECT

						INVOKE	GetDC,hWorkspace
						mov		edi,eax

						INVOKE	GetClientRect,hWorkspace,ADDR _rc

						INVOKE	CreateBitmap,8,8,1,1,ADDR DotPatternBmp

						push	eax

						INVOKE	CreatePatternBrush,eax

						push	eax

						INVOKE	SetBrushOrgEx,edi,dwX,0,NULL

						push	edi
						call	SelectObject

						push	eax

						INVOKE	PatBlt,edi,dwX,0,SPLITTER_WIDTH,_rc.bottom,PATINVERT

						push	edi
						call	SelectObject

						INVOKE	DeleteObject,eax

						call	DeleteObject

						INVOKE	ReleaseDC,hWorkspace,edi

						ret
BV1HDrawXorBar			ENDP

; ---------------------------------------------------------------------------

BV1_WmLButtonDown			PROC

							mov		dwDragMode,TRUE

							INVOKE	SetCapture,hBV1

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	GetCursorPos,ADDR Old_SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR Old_SplitPoint

							INVOKE	BV1HDrawXorBar,SplitPoint.x,SplitPoint.y

							ret
BV1_WmLButtonDown			ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BV1_WmMouseMove				PROC

							cmp		DWord Ptr dwDragMode,0
							je		BV1_WmMouseMove_Exit

							INVOKE	GetCursorPos,ADDR SplitPoint
							INVOKE	ScreenToClient,hWorkspace,ADDR SplitPoint

							INVOKE	BV1HDrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y
							INVOKE	BV1HDrawXorBar,SplitPoint.x,SplitPoint.y

							mov		eax,DWord Ptr SplitPoint.x
							mov		DWord Ptr Old_SplitPoint.x,eax

							mov		eax,DWord Ptr SplitPoint.y
							mov		DWord Ptr Old_SplitPoint.y,eax

BV1_WmMouseMove_Exit :

							ret
BV1_WmMouseMove				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BV1_WmLButtonUp				PROC
							LOCAL	_dwDelta:DWord

							cmp		DWord Ptr dwDragMode,0
							je		BV1_WmLButtonUp_Exit

							INVOKE	ReleaseCapture

							INVOKE	BV1HDrawXorBar,Old_SplitPoint.x,Old_SplitPoint.y

							mov		eax,SplitPoint.x
							sub		eax,rcBV1.left
							mov		_dwDelta,eax

							add		rcFolders.right,eax
							add		rcEffects.right,eax
							add		rcPreview.right,eax
							add		rcBH1.right,eax
							add		rcBH2.right,eax
							add		rcBV1.left,eax
							add		rcThumbnails.left,eax
							sub		rcThumbnails.right,eax

							cmp		rcThumbnails.right,240
							jge		@Next

								mov		rcThumbnails.right,240
								mov		eax,rcWorkspace.right
								sub		eax,240
								mov		rcThumbnails.left,eax
								sub		eax,SPLITTER_WIDTH
								mov		rcFolders.right,eax
								mov		rcBH1.right,eax
								mov		rcEffects.right,eax
								mov		rcBH2.right,eax
								mov		rcPreview.right,eax
								mov		rcBV1.left,eax

@Next :

							cmp		rcFolders.right,240
							jge		@Next1

								mov		rcFolders.right,240
								mov		rcBH1.right,240
								mov		rcEffects.right,240
								mov		rcBH2.right,240
								mov		rcPreview.right,240
								mov		rcBV1.left,240
								mov		rcThumbnails.left,240 + SPLITTER_WIDTH
								mov		eax,rcWorkspace.right
								sub		eax,240
								mov		rcThumbnails.right,eax

@Next1 :

							INVOKE	MoveWindow,hFolders,rcFolders.left,rcFolders.top,rcFolders.right,rcFolders.bottom,TRUE
							INVOKE	MoveWindow,hBH1,rcBH1.left,rcBH1.top,rcBH1.right,rcBH1.bottom,TRUE
							INVOKE	MoveWindow,hEffects,rcEffects.left,rcEffects.top,rcEffects.right,rcEffects.bottom,TRUE
							INVOKE	MoveWindow,hBH2,rcBH2.left,rcBH2.top,rcBH2.right,rcBH2.bottom,TRUE
							INVOKE	MoveWindow,hPreview,rcPreview.left,rcPreview.top,rcPreview.right,rcPreview.bottom,TRUE
							INVOKE	MoveWindow,hBV1,rcBV1.left,rcBV1.top,rcBV1.right,rcBV1.bottom,TRUE
							INVOKE	MoveWindow,hThumbnails,rcThumbnails.left,rcThumbnails.top,rcThumbnails.right,rcThumbnails.bottom,TRUE

							mov		dwDragMode,FALSE

BV1_WmLButtonUp_Exit :

							ret
BV1_WmLButtonUp				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

BV1WndProc					PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,hWnd
							mov		edi,lParam
							mov		ebx,wParam
							mov		eax,uMsg

							.IF	eax == WM_LBUTTONDOWN

								push	OFFSET BV1WndProc_Exit
								jmp		BV1_WmLButtonDown

							.ELSEIF	eax == WM_MOUSEMOVE

								push	OFFSET BV1WndProc_Exit
								jmp		BV1_WmMouseMove

							.ELSEIF	eax == WM_LBUTTONUP

								push	OFFSET BV1WndProc_Exit
								jmp		BV1_WmLButtonUp

							.ELSE

								push	edi
								push	ebx
								push	eax
								push	esi
								push	OFFSET BV1WndProc_End
								jmp		DefWindowProc							

							.ENDIF

BV1WndProc_Exit :

							xor eax,eax

BV1WndProc_End :

							ret
BV1WndProc					ENDP

; ---------------------------------------------------------------------------
