;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================

Original_Image_Draw			PROC	USES EBX EDI ESI,hWnd:HWND,hDC:HDC
							LOCAL	_hDC:HDC
							LOCAL	_hDCMem:HDC
							LOCAL	_hBrush:HBRUSH
							LOCAL	_hBmp:HBITMAP
							LOCAL	_hBmpOld:HBITMAP
							LOCAL	_rc:RECT
							LOCAL	_rcOmbre:RECT
							LOCAL	_rcFilet:RECT
							LOCAL	_dwNewWidth:DWord
							LOCAL	_dwNewHeight:DWord
							LOCAL	_dwXImage:DWord
							LOCAL	_dwYImage:DWord

							cmp		DWord Ptr hDC,NULL
							je		@NohDC

							mov		eax,DWord Ptr hDC
							mov		DWord Ptr _hDC,eax
							jmp		@Next

@NohDC :

							INVOKE	GetDC,hWnd
							mov		DWord Ptr _hDC,eax

@Next :

							cmp		DWord Ptr _hDC,NULL
							je		@Exit

							INVOKE	CreateCompatibleDC,_hDC

							test	eax,eax
							jz		@Error

							mov		DWord Ptr _hDCMem,eax

;	*******************************************
;	*** Prparation du transfert des images ***
;	*******************************************

							INVOKE	SetStretchBltMode,_hDC,COLORONCOLOR
							INVOKE	SetStretchBltMode,_hDCMem,COLORONCOLOR

;	**********************************************
;	*** Peindre le fond de la fentre en blanc ***
;	**********************************************

							INVOKE	GetClientRect,hWnd,ADDR _rc

							INVOKE	CreateSolidBrush,00ffffffh

							test	eax,eax
							jz		@Error_0

							mov		DWord Ptr _hBrush,eax

							INVOKE	CreateCompatibleBitmap,_hDC,_rc.right,_rc.bottom

							test	eax,eax
							jz		@Error_0

							mov		DWord Ptr _hBmp,eax

							INVOKE	SelectObject,_hDCMem,eax

							test	eax,eax
							jz		@Error_1

							mov		DWord Ptr _hBmpOld,eax

							INVOKE	FillRect,_hDCMem,ADDR _rc,_hBrush
							INVOKE	DeleteObject,_hBrush

							mov		edi,DWord Ptr lpProject

;	*********************************************
;	*** Prparation des dimensions de l'image ***
;	*********************************************

comment @
							!--------------------!
							|                    |
							|   +------------+   |	dwDesiredImageWidth = rc.right - 8
							|   |            |   |	dwDesiredImageHeight = rc.bottom - 8
							|   |            |x  |
							|   |            |x  |
							|   |            |x  |	dwXImage = (rc.right - dwNewImageWidth) / 2
							|   |            |x  |	dwYImage = (rc.bottom - dwNewImageHeight) / 2
							|   |            |x  |
							|   |            |x  |	dwXOmbre = dwXImage + 4
							|   |            |x  |	dwYOmbre = dwYImage + 4
							|   +------------+x  |	dwWOmbre = dwNewImageWidth
							|     xxxxxxxxxxxxx  |	dwHOmbre = dwNewImageHeight
							|                    |
							!--------------------!
@

;	****************************************************
;	*** Calculer les nouvelles dimensions de l'image ***
;	****************************************************

							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).Picture.ImageInfo.biHeight
							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).Picture.ImageInfo.biWidth
							lea		eax,(PICTURE_PROJECT Ptr [edi]).Picture.dImageRatio
							push	eax
							mov		eax,DWord Ptr _rc.bottom
							sub		eax,16								; dwDesiredImageHeight
							push	eax
							mov		eax,DWord Ptr _rc.right
							sub		eax,16								; dwDesiredImageWidth
							push	eax
							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).Picture.dwImageSens
							call	Dimensions_Adjust

							mov		DWord Ptr _dwNewWidth,eax
							mov		DWord Ptr _dwNewHeight,edx

;	***************************************
;	*** Centrer l'image horizontalement ***
;	***************************************

							mov		eax,DWord Ptr _rc.right
							sub		eax,DWord Ptr _dwNewWidth
							shr		eax,1
							mov		DWord Ptr _dwXImage,eax

;	********************************
;	*** Positionner l'ombre en X ***
;	********************************

							inc		eax
							mov		DWord Ptr _rcFilet.left,eax

							push	eax
							add		eax,DWord Ptr _dwNewWidth
							mov		DWord Ptr _rcFilet.right,eax
							pop		eax

							add		eax,8
							mov		DWord Ptr _rcOmbre.left,eax

;	**************************************
;	*** Calculer la largeur de l'ombre ***
;	**************************************

							add		eax,DWord Ptr _dwNewWidth
							mov		DWord Ptr _rcOmbre.right,eax

;	*************************************
;	*** Centrer l'image verticalement ***
;	*************************************

							mov		eax,DWord Ptr _rc.bottom
							sub		eax,DWord Ptr _dwNewHeight
							shr		eax,1
							mov		DWord Ptr _dwYImage,eax

;	********************************
;	*** Positionner l'ombre en Y ***
;	********************************

							inc		eax
							mov		DWord Ptr _rcFilet.top,eax

							add		eax,8
							mov		DWord Ptr _rcOmbre.top,eax

;	**************************************
;	*** Calculer la hauteur de l'ombre ***
;	**************************************

							add		eax,DWord Ptr _dwNewHeight
							mov		DWord Ptr _rcOmbre.bottom,eax

							mov		edx,DWord Ptr _dwNewHeight
							add		edx,DWord Ptr _rcFilet.top
							mov		DWord Ptr _rcFilet.bottom,edx

;	************************
;	*** Afficher l'ombre ***
;	************************

							INVOKE	CreateSolidBrush,00808080h
							push	eax
							INVOKE	FillRect,_hDCMem,ADDR _rcOmbre,eax
							call	DeleteObject

;	*************************
;	*** Afficher le filet ***
;	*************************

							INVOKE	CreateSolidBrush,00ffffffh
							push	eax
							INVOKE	FillRect,_hDCMem,ADDR _rcFilet,eax
							call	DeleteObject

;	******************************************
;	*** Centrer l'image dans le DC mmoire ***
;	******************************************

							push	SRCCOPY
							push	DIB_RGB_COLORS
							lea		eax,(PICTURE_PROJECT Ptr [edi]).Picture.ImageInfo
							push	eax
							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).dwPictureDatasOffset
							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).Picture.ImageInfo.biHeight
							push	DWord Ptr (PICTURE_PROJECT Ptr [edi]).Picture.ImageInfo.biWidth
							push	0
							push	0
							push	DWord Ptr _dwNewHeight
							push	DWord Ptr _dwNewWidth
							push	DWord Ptr _dwYImage
							push	DWord Ptr _dwXImage
							push	DWord Ptr _hDCMem
							call	StretchDIBits

;	*****************************************************
;	*** Transfrer l'ensemble de l'oeuvre sur l'cran ***
;	*****************************************************

							INVOKE	BitBlt,_hDC,0,0,_rc.right,_rc.bottom,_hDCMem,0,0,SRCCOPY

							INVOKE	SelectObject,_hDCMem,_hBmpOld

@Error_1 :

							INVOKE	DeleteObject,_hBmp

@Error_0 :

							INVOKE	DeleteDC,_hDCMem

@Error :

							cmp		DWord Ptr hDC,NULL
							jne		@Exit

							INVOKE	ReleaseDC,hWnd,_hDC

@Exit :

							ret
Original_Image_Draw			ENDP

;	================================================================================
