;	================================================================================
							.Code
;	================================================================================

							ALIGN	4


;	================================================================================

;	***********************************************
;	*** A l'entre dans la procdure ESI = hWnd ***
;	***********************************************

;	================================================================================

Project_Close				PROC	USES EBX EDI ESI,lpOldProject:Ptr PICTURE_PROJECT

							mov		eax,DWord Ptr lpOldProject

							test	eax,eax
							jz		@Exit

							INVOKE	Memory_Free,eax

							INVOKE	InvalidateRect,hWndMain,NULL,FALSE

@Exit :

							ret
Project_Close				ENDP

;	================================================================================

Project_Open				PROC	USES EBX EDI ESI,__lpszFileName:LPSTR
							LOCAL	_lpProject:Ptr PICTURE_PROJECT
							LOCAL	_Project:PICTURE_PROJECT
							LOCAL	_dwNumberOfBytesRead:DWord
							LOCAL	_hFile:HANDLE
							LOCAL	_Ofn:OPENFILENAME

							cmp		DWord Ptr __lpszFileName,NULL
							je		@Open

							push	NULL
							push	FILE_ATTRIBUTE_NORMAL
							push	OPEN_EXISTING
							push	NULL
							push	0
							push	GENERIC_READ
							push	DWord Ptr __lpszFileName
							push	OFFSET @Open_Valid
							jmp		CreateFile

@Open :

							mov		DWord Ptr _Ofn.lpstrFilter,OFFSET szProjectFilter
							mov		DWord Ptr _Ofn.lpstrDefExt,OFFSET szPrjDefExt
							mov		DWord Ptr szFullFileName,NULL
							mov		DWord Ptr szFileTitle,NULL
							mov		DWord Ptr _Ofn.nFilterIndex,1
							mov		_Ofn.Flags,OFN_CREATEPROMPT or OFN_ENABLESIZING or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST

							INVOKE	GetOpenFileName,ADDR _Ofn

							test	eax,eax
							jz		@Exit

							INVOKE	CreateFile,_Ofn.lpstrFile,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL

@Open_Valid :

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		DWord Ptr _hFile,eax

							INVOKE	ReadFile,_hFile,ADDR _Project,SIZEOF PICTURE_PROJECT,ADDR _dwNumberOfBytesRead,NULL

							test	eax,eax
							jz		@Read_Error

							cmp		DWord Ptr _dwNumberOfBytesRead,SIZEOF PICTURE_PROJECT
							jne		@Read_Error

							INVOKE	Memory_Alloc,_Project.dwTotalDataSize

							test	eax,eax
							jz		@Read_Error

							mov		DWord Ptr _lpProject,eax

							INVOKE	SetFilePointer,_hFile,0,0,FILE_BEGIN
							INVOKE	ReadFile,_hFile,_lpProject,_Project.dwTotalDataSize,ADDR _dwNumberOfBytesRead,NULL

							test	eax,eax
							jz		@Memory_Error

							mov		eax,DWord Ptr _dwNumberOfBytesRead
							sub		eax,DWord Ptr _Project.dwTotalDataSize
							jnz		@Memory_Error

							INVOKE	CloseHandle,_hFile

							mov		eax,DWord Ptr _lpProject
							push	eax

							mov		edx,DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureDatasOffset
							add		edx,eax
							mov		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureDatasOffset,edx

							mov		edx,DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureWorkOffset
							add		edx,eax
							mov		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureWorkOffset,edx

							mov		edx,DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureTempOffset
							add		edx,eax
							mov		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureTempOffset,edx

							mov		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwProjectModified,FALSE

							INVOKE	InvalidateRect,hWndMain,NULL,FALSE

							pop		eax
							jmp		@Exit

@Memory_Error :

							INVOKE	Memory_Free,_lpProject

@Read_Error :

							INVOKE	CloseHandle,_hFile

@Error :

							INVOKE	InvalidateRect,hWndMain,NULL,FALSE

							xor		eax,eax

@Exit :

							ret
Project_Open				ENDP

;	================================================================================

Project_ReOpen				PROC	USES EBX EDI ESI,__lpszProjectFileName
							LOCAL	_lpProject:Ptr PICTURE_PROJECT
							LOCAL	_Project:PICTURE_PROJECT
							LOCAL	_dwNumberOfBytesRead:DWord
							LOCAL	_hFile:HANDLE

							mov		DWord Ptr _lpProject,NULL

							INVOKE	CreateFile,__lpszProjectFileName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		DWord Ptr _hFile,eax

							INVOKE	ReadFile,_hFile,ADDR _Project,SIZEOF PICTURE_PROJECT,ADDR _dwNumberOfBytesRead,NULL

							test	eax,eax
							jz		@Read_Error

							cmp		DWord Ptr _dwNumberOfBytesRead,SIZEOF PICTURE_PROJECT
							jne		@Read_Error

							INVOKE	Memory_Alloc,_Project.dwTotalDataSize

							test	eax,eax
							jz		@Read_Error

							mov		DWord Ptr _lpProject,eax

							INVOKE	SetFilePointer,_hFile,0,0,FILE_BEGIN
							INVOKE	ReadFile,_hFile,_lpProject,_Project.dwTotalDataSize,ADDR _dwNumberOfBytesRead,NULL

							test	eax,eax
							jz		@Memory_Error

							mov		eax,DWord Ptr _dwNumberOfBytesRead
							sub		eax,DWord Ptr _Project.dwTotalDataSize
							jnz		@Memory_Error

							INVOKE	CloseHandle,_hFile

							mov		eax,DWord Ptr _lpProject

							add		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureDatasOffset,eax
							add		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureWorkOffset,eax
							add		DWord Ptr (PICTURE_PROJECT Ptr [eax]).dwPictureTempOffset,eax

							INVOKE	Memory_Free,_lpProject

							push	DWord Ptr __lpszProjectFileName
							push	OFFSET @Exit
							jmp		Project_Open

@Memory_Error :

							mov		DWord Ptr _lpProject,NULL

@Read_Error :

							INVOKE	CloseHandle,_hFile

@Error :

							INVOKE	InvalidateRect,hWndMain,NULL,FALSE

@Exit :

							mov		eax,DWord Ptr _lpProject

							ret
Project_ReOpen				ENDP

;	================================================================================

Project_Create				PROC	USES EBX EDI ESI,__lpszImageFileName:LPSTR
							LOCAL	_Project:PICTURE_PROJECT
							LOCAL	_szProjectFullFileName[MAX_PATH]:Byte
							LOCAL	_szProjectFileTitle[MAX_PATH]:Byte
							LOCAL	_szProjectDirectory[MAX_PATH]:Byte
							LOCAL	_dwNumberOfBytesWritten:DWord
							LOCAL	_lpImage:Ptr IMAGE_INFOS
							LOCAL	_hFile:HANDLE
							LOCAL	_Ofn:OPENFILENAME

;	************************************
;	*** Initialiser la structure  0 ***
;	************************************

							mov		ecx,(SIZEOF PICTURE_PROJECT) / (SIZEOF DWord)
							xor		eax,eax
							lea		edi,_Project
							rep		stosd

							cmp		DWord Ptr __lpszImageFileName,NULL
							je		@TryToCreate

;	******************************************************************************
;	*** A partir du nom du fichier image on construit le nom du fichier projet ***
;	******************************************************************************

;	=========================================================================
;	=== __lpszImageFileName doit contenir le nom complet du fichier image ===
;	=========================================================================

;	--- Recopier le nom du fichier
;	--- Enlever l'extension
;	--- Ajouter l'extension projet

							INVOKE	GetLocalTime,ADDR _Project.stCreationDate							; Date de cration du fichier
							INVOKE	GetLocalTime,ADDR _Project.stLastModifDate							; Date de la dernire modification

							INVOKE	lstrcpy,ADDR _szProjectFullFileName,__lpszImageFileName
							INVOKE	PathRenameExtension,ADDR _szProjectFullFileName,ADDR szDefPrjExt
							INVOKE	lstrcpy,ADDR szFullFileName,ADDR _szProjectFullFileName
							INVOKE	lstrcpy,ADDR _Project.szProjectFullFileName,ADDR szFullFileName		; Nom complet du fichier projet

							INVOKE	lstrcpy,ADDR szCurrentDirectory,ADDR _szProjectFullFileName
							INVOKE	PathRemoveFileSpec,ADDR szCurrentDirectory
							INVOKE	PathAddBackslash,ADDR szCurrentDirectory
							INVOKE	lstrcpy,ADDR _Project.szProjectDirectory,ADDR szCurrentDirectory	; Rpertoire de travail

							INVOKE	lstrcpy,ADDR szFileTitle,ADDR _szProjectFullFileName
							INVOKE	PathStripPath,ADDR szFileTitle
							INVOKE	lstrcpy,ADDR _Project.szProjectFileTitle,ADDR szFileTitle			; Nom du fichier projet uniquement

							mov		DWord Ptr _Project.dwSignature,"ONAZ"								; Signature du programme
							mov		DWord Ptr _Project.dwStructureSize,SIZEOF PICTURE_PROJECT			; Taille de la structure projet
							mov		DWord Ptr _Project.dwVersion,24121959h								; Version du programme

							jmp		@NowCreate

@TryToCreate :

							mov		DWord Ptr _Ofn.lpstrFilter,OFFSET szProjectFilter
							mov		DWord Ptr _Ofn.lpstrDefExt,OFFSET szPrjDefExt
							mov		DWord Ptr szFullFileName,NULL
							mov		DWord Ptr szFileTitle,NULL
							mov		DWord Ptr _Ofn.nFilterIndex,1
							mov		_Ofn.Flags,OFN_CREATEPROMPT or OFN_ENABLESIZING or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST

							INVOKE	GetOpenFileName,ADDR _Ofn

							test	eax,eax
							jz		@Exit

;	********************************
;	*** Initialisations diverses ***
;	********************************

							mov		DWord Ptr _Project.dwSignature,"ONAZ"								; Signature du programme
							mov		DWord Ptr _Project.dwStructureSize,SIZEOF PICTURE_PROJECT			; Taille de la structure projet
							mov		DWord Ptr _Project.dwVersion,24121959h								; Version du programme

							INVOKE	GetLocalTime,ADDR _Project.stCreationDate							; Date de cration du fichier
							INVOKE	GetLocalTime,ADDR _Project.stLastModifDate							; Date de la dernire modification

							INVOKE	lstrcpy,ADDR szCurrentDirectory,ADDR szFullFileName					; Nom complet du fichier projet
							INVOKE	PathRemoveFileSpec,ADDR szCurrentDirectory
							INVOKE	PathAddBackslash,ADDR szCurrentDirectory

							INVOKE	lstrcpy,ADDR _Project.szProjectFullFileName,ADDR szFullFileName		; Nom complet du fichier projet
							INVOKE	lstrcpy,ADDR _Project.szProjectFileTitle,ADDR szFileTitle			; Nom du fichier projet uniquement
							INVOKE	lstrcpy,ADDR _Project.szProjectDirectory,ADDR szCurrentDirectory	; Rpertoire de travail

							mov		DWord Ptr _Ofn.lpstrFilter,OFFSET szImageFilter
							mov		DWord Ptr _Ofn.lpstrDefExt,OFFSET szBmpDefExt
							mov		DWord Ptr szFullFileName,NULL
							mov		DWord Ptr szFileTitle,NULL
							mov		DWord Ptr _Ofn.nFilterIndex,2
							mov		_Ofn.Flags,OFN_CREATEPROMPT or OFN_ENABLESIZING or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST

							INVOKE	GetOpenFileName,ADDR _Ofn

							test	eax,eax
							jz		@Exit

;	***********************************************************************
;	*** Rcuprer le nom du dossier depuis lequel est charg le fichier ***
;	*** Rcuprer le nom du fichier ainsi que le son nom complet        ***
;	***********************************************************************

							INVOKE	lstrcpy,ADDR szCurrentDirectory,ADDR szFullFileName
							INVOKE	PathRemoveFileSpec,ADDR szCurrentDirectory
							INVOKE	PathAddBackslash,ADDR szCurrentDirectory

							INVOKE	lstrcpy,ADDR _Project.szWorkFileFullFileName,ADDR szFullFileName		; Nom complet du fichier image
							INVOKE	lstrcpy,ADDR _Project.szWorkFileFileTitle,ADDR szFileTitle				; Nom du fichier image
							INVOKE	lstrcpy,ADDR _Project.szWorkFileDirectory,ADDR szCurrentDirectory		; Rpertoire de chargement de l'image

@NowCreate :

;	***********************************************************************
;	*** Rcuprer les infos de l'image sans charger les bits de donnes ***
;	***********************************************************************

							INVOKE	GDIPlus_LoadImageFromFile,ADDR _Project.szWorkFileFullFileName

							test	eax,eax
							jz		@Exit

							mov		DWord Ptr _lpImage,eax													; Sauvegarde du pointeur sur les donnes IMAGE_INFOS
							mov		edi,eax

;	****************************************************************
;	*** Rcuprer les informations relatives au fichier physique ***
;	****************************************************************

							INVOKE	FindFirstFile,ADDR _Project.szWorkFileFullFileName,ADDR _Project.Fichier_Datas
							INVOKE	FindClose,eax

;	**********************************************
;	*** Recopier la structure BITMAPINFOHEADER ***
;	**********************************************

							push	edi

							mov		esi,edi
							lea		edi,_Project.Picture.Image
							mov		ecx,(SIZEOF BITMAPINFOHEADER) / (SIZEOF DWord)
							rep		movsd

							pop		edi

							mov		DWord Ptr _Project.Picture.dwStructureSize,SIZEOF IMAGE_INFOS

							mov		eax,(IMAGE_INFOS Ptr [edi]).dwImageSens
							mov		DWord Ptr _Project.Picture.dwImageSens,eax

							mov		eax,(IMAGE_INFOS Ptr [edi]).dwTotalDatasSize			; Taille de la structure IMAG_INFOS
							mov		DWord Ptr _Project.Picture.dwTotalDatasSize,eax			; Plus taille de l'image

							fld		(IMAGE_INFOS Ptr [edi]).dImageRatio
							fst		QWord Ptr _Project.Picture.dImageRatio

							mov		DWord Ptr _Project.Tranches.dwStructureSize,SIZEOF PICTURE_TRANCHES

							mov		DWord Ptr _Project.Tranches.dwGamma_T1,255
							mov		DWord Ptr _Project.Tranches.dwGamma_T2,255
							mov		DWord Ptr _Project.Tranches.dwGamma_T3,255
							mov		DWord Ptr _Project.Tranches.dwGamma_Rgb,255

;	****************************************************
;	*** Initialisation des pointeurs sur les donnes ***
;	****************************************************

							mov		DWord Ptr _Project.Picture.dwImageBitsOffset,SIZEOF IMAGE_INFOS
							mov		DWord Ptr _Project.dwPictureDatasOffset,SIZEOF PICTURE_PROJECT			; Sauver le pointeur

							mov		eax,SIZEOF PICTURE_PROJECT												; Taille de la structure PICTURE_PROJECT
							add		eax,DWord Ptr _Project.Picture.Image.biSizeImage						; Taille de l'image
							mov		DWord Ptr _Project.dwPictureWorkOffset,eax								; Sauver le pointeur

							add		eax,DWord Ptr _Project.Picture.Image.biSizeImage						; Taille de l'image
							mov		DWord Ptr _Project.dwPictureTempOffset,eax								; Sauver le pointeur

							add		eax,DWord Ptr _Project.Picture.Image.biSizeImage						; Taille de l'image
							add		DWord Ptr _Project.dwTotalDataSize,eax									; Taille totale des donnes

;	*******************************
;	*** Crer le fichier projet ***
;	*******************************

							INVOKE	CreateFile,ADDR _Project.szProjectFullFileName,GENERIC_READ or GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		DWord Ptr _hFile,eax

;	********************************************
;	*** Ecrire les donnes propres au projet ***
;	********************************************

							INVOKE	WriteFile,_hFile,ADDR _Project,SIZEOF PICTURE_PROJECT,ADDR _dwNumberOfBytesWritten,NULL

							test	eax,eax
							jz		@Write_Error

							mov		eax,DWord Ptr _dwNumberOfBytesWritten
							sub		eax,SIZEOF PICTURE_PROJECT
							jnz		@Write_Error

;	************************************************************
;	*** Ecrire les donnes de l'image qui serviront au RESET ***
;	************************************************************

							INVOKE	WriteFile,_hFile,(IMAGE_INFOS Ptr [edi]).lpImageBits,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage,ADDR _dwNumberOfBytesWritten,NULL

							test	eax,eax
							jz		@Write_Error

							mov		eax,DWord Ptr _dwNumberOfBytesWritten
							sub		eax,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage
							jnz		@Write_Error

;	**************************************************************************
;	*** Ecrire les donnes de l'image qui serviront au travaux temporaires ***
;	**************************************************************************

							INVOKE	WriteFile,_hFile,(IMAGE_INFOS Ptr [edi]).lpImageBits,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage,ADDR _dwNumberOfBytesWritten,NULL

							test	eax,eax
							jz		@Write_Error

							mov		eax,DWord Ptr _dwNumberOfBytesWritten
							sub		eax,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage
							jnz		@Write_Error

;	****************************************************************
;	*** Ecrire les donnes de l'image qui serviront aux TRANCHES ***
;	****************************************************************

							INVOKE	WriteFile,_hFile,(IMAGE_INFOS Ptr [edi]).lpImageBits,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage,ADDR _dwNumberOfBytesWritten,NULL

							test	eax,eax
							jz		@Write_Error

							mov		eax,DWord Ptr _dwNumberOfBytesWritten
							sub		eax,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage
							jnz		@Write_Error

;	*************************
;	*** Fermer le fichier ***
;	*************************

							INVOKE	CloseHandle,_hFile

;	**************************
;	*** Librer la mmoire ***
;	**************************

							INVOKE	Memory_Free,_lpImage						; Dcharger l'image de la mmoire

;	*****************************************************
;	*** R-Ouvrir le fichier projet pour vrification ***
;	*****************************************************

							lea		eax,_Project.szProjectFullFileName
							push	eax
							push	OFFSET @Exit
							jmp		Project_ReOpen 

@Write_Error :

							INVOKE	CloseHandle,_hFile
							INVOKE	DeleteFile,ADDR _Project.szProjectFullFileName
							INVOKE	Memory_Free,_lpImage						; Dcharger l'image de la mmoire

@Error :

							INVOKE	InvalidateRect,hWndMain,NULL,FALSE

							xor		eax,eax

@Exit :

							ret
Project_Create				ENDP

;	================================================================================

Project_Save				PROC	USES EBX EDI ESI,__lpActualProject:Ptr PICTURE_PROJECT
							LOCAL	_hFile:HANDLE
							LOCAL	_dwNumberOfBytesWritten:DWord

							mov		edi,DWord Ptr __lpActualProject

							test	edi,edi
							jz		@Error

;	*******************************
;	*** Crer le fichier projet ***
;	*******************************

							INVOKE	CreateFile,ADDR (PICTURE_PROJECT Ptr [edi]).szProjectFullFileName,GENERIC_READ or GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		DWord Ptr _hFile,eax

;	********************************************
;	*** Ecrire les donnes propres au projet ***
;	********************************************

							mov		esi,DWord Ptr (PICTURE_PROJECT Ptr [edi]).dwProjectModified
							mov		DWord Ptr (PICTURE_PROJECT Ptr [edi]).dwProjectModified,FALSE

							INVOKE	WriteFile,_hFile,edi,(PICTURE_PROJECT Ptr [edi]).dwTotalDataSize,ADDR _dwNumberOfBytesWritten,NULL

							test	eax,eax
							jz		@Save_Error

							mov		eax,DWord Ptr _dwNumberOfBytesWritten
							sub		eax,(PICTURE_PROJECT Ptr [edi]).dwTotalDataSize
							jnz		@Save_Error

;	*************************
;	*** Fermer le fichier ***
;	*************************

							INVOKE	CloseHandle,_hFile

							INVOKE	InvalidateRect,esi,NULL,FALSE

							mov		eax,TRUE
							jmp		@Exit

@Save_Error :

							INVOKE	CloseHandle,_hFile

							mov		DWord Ptr (PICTURE_PROJECT Ptr [edi]).dwProjectModified,esi

@Error :

							xor		eax,eax

							INVOKE	InvalidateRect,esi,NULL,FALSE

@Exit :

							ret
Project_Save				ENDP

;	================================================================================
