;	================================================================================
							.Code
;	================================================================================


							ALIGN	4

ThreadFindFilesProc			PROC	USES EBX EDI ESI,__lpszDirectory:LPSTR
							LOCAL	_Lvi:LVITEM
							LOCAL	_Wf:WIN32_FIND_DATA
							LOCAL	_szOldDirectory[MAX_PATH]:Byte
							LOCAL	_szNewDirectory[MAX_PATH]:Byte
							LOCAL	_szFullFileName[MAX_PATH]:Byte

							INVOKE	SendMessage,hList_Icons,LVM_DELETEALLITEMS,0,0
							INVOKE	ImageList_Remove,hImageList,-1

							mov		_Lvi.imask,LVIF_DI_SETITEM or LVIF_IMAGE or LVIF_PARAM or LVIF_TEXT
							mov		_Lvi.iItem,0
							mov		_Lvi.iSubItem,0
							lea		eax,_Wf.cFileName
							mov		_Lvi.pszText,eax
							mov		_Lvi.iImage,I_IMAGECALLBACK

							INVOKE	GetCurrentDirectory,MAX_PATH,ADDR _szOldDirectory
							INVOKE	SetCurrentDirectory,__lpszDirectory

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Exit

							mov		esi,eax

@Found :

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							mov		eax,_Wf.dwFileAttributes

							and		eax,FILE_ATTRIBUTE_DIRECTORY
							jnz		@Next

							INVOKE	lstrcpy,ADDR _szFullFileName,__lpszDirectory

							INVOKE	StrLen,ADDR _szFullFileName

							dec		eax
							lea		edx,_szFullFileName

							cmp		Byte Ptr [eax + edx],'\'
							je		@NoSlash

							INVOKE	lstrcat,ADDR _szFullFileName,ADDR szBackSlash

@NoSlash :

							INVOKE	lstrcat,ADDR _szFullFileName,ADDR _Wf.cFileName

							INVOKE	GDIPlus_CanILoadThisFile,ADDR _szFullFileName

							test	eax,eax
							jz		@Next

							INVOKE	StrLen,ADDR _szFullFileName

							add		eax,5
							shr		eax,2
							shl		eax,2

							INVOKE	Memory_Alloc,eax

							test	eax,eax
							jz		@Next

							mov		edi,eax

							INVOKE	lstrcpy,edi,ADDR _szFullFileName

							mov		_Lvi.lParam,edi

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FILE_FOUND,ADDR _Wf,edi

							INVOKE	SendMessage,hList_Icons,LVM_INSERTITEM,0,ADDR _Lvi

							mov		_Lvi.iItem,eax

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_ADDED,eax,NULL

@Next :

							INVOKE	FindNextFile,esi,ADDR _Wf

							test	eax,eax
							jz		@EndLoop

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							mov		eax,_Wf.dwFileAttributes

							and		eax,FILE_ATTRIBUTE_DIRECTORY
							jnz		@Next

							INVOKE	lstrcpy,ADDR _szFullFileName,__lpszDirectory

							INVOKE	StrLen,ADDR _szFullFileName

							dec		eax
							lea		edx,_szFullFileName

							cmp		Byte Ptr [eax + edx],'\'
							je		@NoBackSlash

							INVOKE	lstrcat,ADDR _szFullFileName,ADDR szBackSlash

@NoBackSlash :

							INVOKE	lstrcat,ADDR _szFullFileName,ADDR _Wf.cFileName

							INVOKE	GDIPlus_CanILoadThisFile,ADDR _szFullFileName

							test	eax,eax
							jnz		@Found

							jmp		@Next

@EndLoop :

							INVOKE	FindClose,esi
							INVOKE	SetCurrentDirectory,ADDR _szOldDirectory

@Exit :

							ret
ThreadFindFilesProc			ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmFolderSelected	PROC	USES EBX EDI ESI,__lpszDirectoryName:LPSTR

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadFindFilesProc,__lpszDirectoryName,0,NULL

							push	eax
							push	OFFSET @Exit
							jmp		CloseHandle

@Exit :

							ret
Thumbnails_WmFolderSelected	ENDP

;	================================================================================

CreateListView				PROC	USES EBX EDI ESI
							LOCAL	_rc:RECT

							INVOKE	GetClientRect,esi,ADDR _rc

							push	NULL
							push	DWord Ptr hInstance
							push	IDC_LIST_01
							push	esi
							push	_rc.bottom
							push	_rc.right
							push	0
							push	0
							push	WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or WS_VSCROLL or LVS_ICON or LVS_SHOWSELALWAYS or LVS_SHAREIMAGELISTS or LVS_AUTOARRANGE or LVS_EDITLABELS
							push	OFFSET szNullString
							push	OFFSET szListViewClass
							push	WS_EX_CLIENTEDGE
							call	CreateWindowEx

							mov		hList_Icons,eax

							push	LVS_EX_INFOTIP or LVS_EX_UNDERLINEHOT or LVS_EX_UNDERLINECOLD or LVS_EX_LABELTIP or LVS_EX_BORDERSELECT or LVS_EX_DOUBLEBUFFER
							push	0
							push	LVM_SETEXTENDEDLISTVIEWSTYLE
							push	eax
							call	SendMessage

							INVOKE	SendMessage,hList_Icons,WM_SETFONT,hMainFont,TRUE

							INVOKE	ImageList_Create,dwDiapo_Width,dwDiapo_Height,ILC_COLOR32,1,1

							mov		hImageList,eax

							INVOKE	SendMessage,hList_Icons,LVM_SETIMAGELIST,LVSIL_NORMAL,eax

							ret
CreateListView				ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmCreate			PROC	USES EBX EDI ESI

							mov		dwDiapo_Width,256
							mov		dwDiapo_Height,192

							call	CreateListView

							ret
Thumbnails_WmCreate			ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmClose			PROC	USES EBX EDI ESI

							INVOKE	ImageList_Destroy,hImageList

							ret
Thumbnails_WmClose			ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmSize			PROC	USES EBX EDI ESI,_dwNewWidth:DWord,_dwNewHeight:DWord

							INVOKE	MoveWindow,hList_Icons,0,0,_dwNewWidth,_dwNewHeight,TRUE

							ret
Thumbnails_WmSize			ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmNotify			PROC	USES EBX EDI ESI
							LOCAL	_hDC:HDC
							LOCAL	_hDCMem:HDC
							LOCAL	_hBitmap:HBITMAP
							LOCAL	_hBmpOld:HBITMAP
							LOCAL	_dwNewWidth:DWord
							LOCAL	_dwNewHeight:DWord
							LOCAL	_dwNewX:DWord
							LOCAL	_dwNewY:DWord
							LOCAL	_pt:POINT
							LOCAL	_lpImage:Ptr IMAGE_INFOS
							LOCAL	_rc:RECT

							mov		_lpImage,NULL

							cmp		(NMLVDISPINFO Ptr [edi]).hdr.code,LVN_GETDISPINFO
							jne		@End

							test	(NMLVDISPINFO Ptr [edi]).item.imask,LVIF_IMAGE
							jz		@End

							INVOKE	GDIPlus_LoadImageFromFile,(NMLVDISPINFO Ptr [edi]).item.lParam

							test	eax,eax
							jz		@End

							mov		_lpImage,eax
							mov		ebx,eax

							INVOKE	GetDC,esi

							test	eax,eax
							jz		@Exit

							mov		_hDC,eax

							INVOKE	CreateCompatibleDC,eax						; _hDC
							mov		_hDCMem,eax

							INVOKE	CreateCompatibleBitmap,_hDC,dwDiapo_Width,dwDiapo_Height
							mov		_hBitmap,eax

							INVOKE	SelectObject,_hDCMem,eax
							mov		_hBmpOld,eax

							INVOKE	SetRect,ADDR _rc,0,0,dwDiapo_Width,dwDiapo_Height
							INVOKE	FillRect,_hDCMem,ADDR _rc,COLOR_WINDOW + 1

							INVOKE	Dimensions_Compute,_lpImage,dwDiapo_Width,dwDiapo_Height

							mov		_dwNewWidth,eax
							mov		_dwNewHeight,edx

							INVOKE	SetStretchBltMode,_hDCMem,COLORONCOLOR

							mov		eax,dwDiapo_Width
							sub		eax,_dwNewWidth
							shr		eax,1
							mov		_dwNewX,eax

							mov		eax,dwDiapo_Height
							sub		eax,_dwNewHeight
							shr		eax,1
							mov		_dwNewY,eax

							INVOKE	StretchDIBits,_hDCMem,_dwNewX,_dwNewY,_dwNewWidth,_dwNewHeight,0,0,(IMAGE_INFOS Ptr [ebx]).Image.biWidth,(IMAGE_INFOS Ptr [ebx]).Image.biHeight,(IMAGE_INFOS Ptr [ebx]).lpImageBits,ADDR (IMAGE_INFOS Ptr [ebx]).Image,DIB_RGB_COLORS,SRCCOPY
							INVOKE	SelectObject,_hDCMem,_hBmpOld

							INVOKE	Memory_Free,_lpImage
							mov		_lpImage,NULL

							INVOKE	SendMessage,hList_Icons,LVM_GETITEMPOSITION,(NMLVDISPINFO Ptr [edi]).item.iItem,ADDR _pt

							test	eax,eax
							jz		@Finished

							INVOKE	ImageList_Add,hImageList,_hBitmap,NULL

;							push	eax

							INVOKE	ImageList_Draw,hImageList,eax,_hDC,_pt.x,_pt.y,ILD_NORMAL

							INVOKE	DeleteObject,_hBitmap

@Finished :

;							push	hImageList
;							call	ImageList_Remove

							push	_hDC
							push	esi
							push	OFFSET @End
							jmp		ReleaseDC

@Exit :

							cmp		_lpImage,NULL
							je		@End

							INVOKE	Memory_Free,_lpImage

@End :

							ret
Thumbnails_WmNotify			ENDP

;	================================================================================

;	*** EDI = lParam
;	*** ESI = hWnd
;	*** EBX = wParam

;	================================================================================

Thumbnails_WmCommand		PROC	USES EBX EDI ESI
							ret
Thumbnails_WmCommand		ENDP

;	================================================================================

ThumbnailsWndProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_IVIEW_FOLDER_SELECTED
							jne		@F

								push	edi
								push	OFFSET @Exit
								jmp		Thumbnails_WmFolderSelected

@@ :

							cmp		eax,WM_ERASEBKGND
							jne		@F

								mov		eax,TRUE
								jmp		@Exit

@@ :

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @End
								jmp		Thumbnails_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Thumbnails_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								mov		eax,edi
								and		eax,0000ffffh
								shr		edi,16

								push	edi
								push	eax
								push	OFFSET @Exit
								jmp		Thumbnails_WmSize

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	OFFSET @Exit
								jmp		Thumbnails_WmNotify

@@ :

							cmp		eax,WM_COMMAND
							jne		@F

								movzx	eax,Word Ptr wParam + 2
								push	eax
								movzx	eax,Word Ptr wParam
								push	eax
								push	OFFSET @End
								jmp		Thumbnails_WmCommand

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
ThumbnailsWndProc			ENDP

;	================================================================================

Thumbnails_Create :

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE or WS_EX_TOOLWINDOW,\
									ADDR szThumbnailsClass,ADDR szThumbnailsName,WS_CAPTION or WS_CHILD or WS_VISIBLE,\
									rcThumbnails.left,rcThumbnails.top,rcThumbnails.right,rcThumbnails.bottom,\
									esi,1904h,hInstance,NULL

							push	eax

							push	eax

							push	SW_SHOW
							push	eax
							call	ShowWindow
							call	UpdateWindow

							pop		eax

							ret

;	================================================================================
