;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================

Workspace_SetDimpensions		PROC	USES EBX EDI ESI,_dwWidth:DWord,_dwHeight:DWord
								LOCAL	_dwLargeur_25:DWord
								LOCAL	_dwLargeur_75:DWord
								LOCAL	_dwHauteur_25:DWord
								LOCAL	_dwHauteur_37:DWord

								mov		eax,_dwWidth
								shr		eax,2						; 25%
								mov		_dwLargeur_25,eax

								mov		edx,_dwWidth
								sub		edx,eax						; 75%
								mov		_dwLargeur_75,edx

								mov		eax,_dwHeight
								shr		eax,2
								mov		_dwHauteur_25,eax			; 25%

								mov		edx,_dwHeight
								sub		edx,eax
								shr		edx,1
								mov		_dwHauteur_37,eax			; 37.50%

;	================================================================================

comment	@
	+---------------------------------------------------------------------------------------------------------------+
	!                                   TOOLBAR                                                                     !
	+---------------------------+-----------------------------------------------------------------------------------+
	!                           !                                                                                   !
	!                           !                                                                                   !
	!  FOLDERS                  !                                                                                   !
	!                           ! BV1                                                                               !
	!                           !                                                                                   !
	!   Largeur 25%             !                                                                                   !
	!   Hauteur 37.5%           !                                                                                   !
	!                           !                                                                                   !
	!                           !                     THUMBNAILS                                                    !
	!                           !                                                                                   !
	!       BH1                 !                                                                                   !
	+---------------------------+                     Largeur 75%                                                   !
	!         Largeur 25%       !                     Hauteur 100%                                                  !
	!     EFFECTS               !                                                                                   !
	!         Hauteur 25%       !                                                                                   !
	+---------------------------+                                                                                   !
	!       BH2                 !                                                                                   !
	!                           !                                                                                   !
	!                           !                                                                                   !
	!                           !                                                                                   !
	!      PREVIEW              !                                                                                   !
	!                           !                                                                                   !
	!  Largeur 25%              !                                                                                   !
	!  Hauteur 37.5%            !                                                                                   !
	!                           !                                                                                   !
	!                           !                                                                                   !
	+---------------------------------------------------------------------------------------------------------------!
	!                           STATUSBAR                                                                           !
	+---------------------------------------------------------------------------------------------------------------+
@

;	================================================================================

								xor		eax,eax

								mov		rcBV1.top,eax
								mov		rcBH1.left,eax
								mov		rcBH2.left,eax
								mov		rcFolders.left,eax
								mov		rcFolders.top,eax
								mov		rcEffects.left,eax
								mov		rcPreview.left,eax

								mov		rcBV1.right,SPLITTER_WIDTH
								mov		rcBH1.bottom,SPLITTER_HEIGHT
								mov		rcBH2.bottom,SPLITTER_HEIGHT

								mov		eax,_dwLargeur_25
								mov		rcFolders.right,eax
								mov		rcEffects.right,eax
								mov		rcPreview.right,eax
								mov		rcBH1.right,eax
								mov		rcBH2.right,eax
								mov		rcBV1.left,eax

								add		eax,SPLITTER_WIDTH
								mov		rcThumbnails.left,eax
								mov		edx,_dwWidth
								sub		edx,eax
								mov		rcThumbnails.right,edx

								mov		eax,_dwHauteur_25
								mov		rcEffects.bottom,eax
								mov		edx,_dwHeight
								sub		edx,eax
								sub		edx,2 * SPLITTER_HEIGHT
								shr		edx,1
								mov		rcFolders.bottom,edx
								mov		rcBH1.top,edx
								mov		rcPreview.bottom,edx
								add		edx,SPLITTER_HEIGHT
								mov		rcEffects.top,edx
								add		edx,rcEffects.bottom
								mov		rcBH2.top,edx
								add		edx,SPLITTER_HEIGHT
								mov		rcPreview.top,edx

								mov		eax,_dwHeight
								mov		rcBV1.bottom,eax
								mov		rcThumbnails.bottom,eax

								ret
Workspace_SetDimpensions		ENDP

;	================================================================================

Workspace_WmCreate				PROC	USES EBX EDI ESI
								LOCAL	_rc:RECT

								INVOKE	GetClientRect,esi,ADDR _rc
								INVOKE	Workspace_SetDimpensions,_rc.right,_rc.bottom

								call	Folders_Create
								mov		hFolders,eax

								call	CreateBH1
								mov		hBH1,eax

								call	Effects_Create
								mov		hEffects,eax

								call	CreateBH2
								mov		hBH2,eax

								call	Preview_Create
								mov		hPreview,eax

								call	CreateBV1
								mov		hBV1,eax

								call	Thumbnails_Create
								mov		hThumbnails,eax

								mov		eax,TRUE
								ret
Workspace_WmCreate				ENDP

;	================================================================================

Workspace_WmSize			PROC	USES EBX EDI ESI,_dwNewWidth:DWord,_dwNewHeight:DWord

							mov		rcWorkspace.left,0
							mov		rcWorkspace.top,0

							mov		eax,_dwNewWidth
							mov		rcWorkspace.right,eax

							mov		eax,_dwNewHeight
							mov		rcWorkspace.bottom,eax

							INVOKE	Workspace_SetDimpensions,_dwNewWidth,_dwNewHeight

							ret
Workspace_WmSize			ENDP

;	================================================================================

WorkspaceWndProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @Exit
								jmp		Workspace_WmCreate

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								mov		eax,edi
								and		eax,0000ffffh
								shr		edi,16

								push	edi
								push	eax
								push	OFFSET @Exit
								jmp		Workspace_WmSize

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
WorkspaceWndProc			ENDP

;	================================================================================

Workspace_Create			PROC	USES EBX EDI ESI,__lpRect:Ptr RECT

							mov		edi,DWord Ptr __lpRect

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE,\
									ADDR szWorkspaceClass,ADDR szWorkspaceName,WS_CHILD or WS_VISIBLE or WS_BORDER,\
									(RECT Ptr [edi]).left,(RECT Ptr [edi]).top,(RECT Ptr [edi]).right,(RECT Ptr [edi]).bottom,\
									esi,1900h,hInstance,NULL

							ret
Workspace_Create			ENDP

;	================================================================================
