; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

;	========================================================================================================================

;	**********************************************
;	*** A la sortie : EAX = Nouvelle largeur   ***
;	***             : EDX = Nouvelle hauteur   ***
;	**********************************************

Dimensions_ComputeEx	PROC	USES EBX EDI ESI,lpImage:Ptr IMAGE_INFOS,dwWidth:DWord,dwHeight:DWord
						LOCAL	_dwNewWidth:DWord
						LOCAL	_dwNewHeight:DWord
						LOCAL	_dwLower:DWord

						mov		edi,lpImage

;	=========================================================================================
;	=== Calcul de la taille de l'image de faon  ce qu'elle tienne dans la zone client   ===
;	=== Cette taille prend en compte le rapport entre la largeur et la hauteur de l'image ===
;	=== Cette technique permet de conserver les proportions de la nouvelle image          ===
;	=========================================================================================

;	===========================================================
;	=== Si l'image est horizontale (W > H) => H = W / Ratio ===
;	=== Si l'image est verticale   (H > W) => W = H * Ratio ===
;	===========================================================

						cmp		DWord Ptr (IMAGE_INFOS Ptr [edi]).dwImageSens,IMAGE_HORIZONTALE
						je		Dimensions_ComputeEx_Horizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Dimensions_ComputeEx_Verticale :

						fild	DWord Ptr [dwHeight]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,dwWidth

						cmp		eax,_dwNewWidth
						jl		@F

						mov		eax,DWord Ptr [dwHeight]
						mov		DWord Ptr [_dwNewHeight],eax
						jmp		Dimensions_ComputeEx_Control

@@ :

						fild	DWord Ptr [dwWidth]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,dwWidth
						mov		_dwNewWidth,eax
						jmp		Dimensions_ComputeEx_Control

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Dimensions_ComputeEx_Horizontale :

						fild	DWord Ptr [dwWidth]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,dwHeight

						cmp		eax,_dwNewHeight
						jl		@F

						mov		eax,DWord Ptr [dwWidth]
						mov		DWord Ptr [_dwNewWidth],eax
						jmp		Dimensions_ComputeEx_Control

@@ :

						fild	DWord Ptr [dwHeight]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,dwHeight
						mov		_dwNewHeight,eax

;	=====================================================
;	=== Si l'image est presque carre, il se peut que ===
;	=== l'une des deux coordonnes soit fausse        ===
;	=====================================================

Dimensions_ComputeEx_Control :

;	=======================================================================
;	=== Exemple : Largeur = 768 et Hauteur = 766 => Ratio = 0.997395833 ===
;	=== Le ratio est proche de 1                                        ===
;	=== Dans ce cas, il faut prendre la plus petite dimension entre la  ===
;	=== largeur et la hauteur de la zone client                         ===
;	=======================================================================

;	=============================================================================
;	=== Pour dterminer si le ratio est de 1, je propose la mthode suivante  ===
;	=== Diviser la largeur par 10 puis la multiplier  nouveau par 10         ===
;	=== Faire la mme chose avec la hauteur                                   ===
;	=== Dans le cas prcdent, nous aurions une largeur de 760 et une hauteur ===
;	=== de 760, les deux tant identiques, le ratio est de 1.                 ===
;	=============================================================================

;	=======================================
;	=== Calcul de la largeur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth
						mov		ebx,10
						div		bx

						lea		eax,[eax+4*eax]
						shl		eax,1

						mov		ecx,eax

;	=======================================
;	=== Calcul de la hauteur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
						mov		ebx,10
						div		bx

						lea		eax,[eax+4*eax]
						shl		eax,1

;	====================================================
;	=== Comparaison des deux dimmensions correctives ===
;	====================================================

						sub		eax,ecx						; Si le rsultat est  0
						jnz		Dimensions_ComputeEx_Continue	; Le ration est de 1

;	===============================================================
;	=== Prendre la dimension la plus petite entre la largeur et ===
;	=== la hauteur de la zone client                            ===
;	===============================================================

						mov		eax,DWord Ptr [dwWidth]
						mov		edx,DWord Ptr [dwHeight]

						cmp		eax,edx
						cmovge	eax,edx

						mov		DWord Ptr [_dwLower],eax

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth

						cmp		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
						jg		Dimensions_ComputeEx_AdjustHorizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Dimensions_ComputeEx_AdjustVerticale :

						fild	DWord Ptr [_dwLower]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,DWord Ptr [_dwLower]
						mov		DWord Ptr [_dwNewHeight],eax

						jmp		Dimensions_ComputeEx_Continue

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Dimensions_ComputeEx_AdjustHorizontale :

						fild	DWord Ptr [_dwLower]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,DWord Ptr [_dwLower]
						mov		DWord Ptr [_dwNewWidth],eax

Dimensions_ComputeEx_Continue :

						mov		eax,DWord Ptr [_dwNewWidth]
						mov		edx,DWord Ptr [_dwNewHeight]

						ret
Dimensions_ComputeEx	ENDP

;	========================================================================================================================

;	**********************************************
;	*** A la sortie : EAX = Nouvelle largeur   ***
;	***             : EDX = Nouvelle hauteur   ***
;	**********************************************

Dimensions_Compute		PROC	USES EBX EDI ESI,lpImage:Ptr IMAGE_INFOS,dwWidth:DWord,dwHeight:DWord
						LOCAL	_dwNewWidth:DWord
						LOCAL	_dwNewHeight:DWord
						LOCAL	_dwLower:DWord

						mov		edi,lpImage

;	=========================================================================================
;	=== Calcul de la taille de l'image de faon  ce qu'elle tienne dans la zone client   ===
;	=== Cette taille prend en compte le rapport entre la largeur et la hauteur de l'image ===
;	=== Cette technique permet de conserver les proportions de la nouvelle image          ===
;	=========================================================================================

;	===========================================================
;	=== Si l'image est horizontale (W > H) => H = W / Ratio ===
;	=== Si l'image est verticale   (H > W) => W = H * Ratio ===
;	===========================================================

						cmp		DWord Ptr (IMAGE_INFOS Ptr [edi]).dwImageSens,IMAGE_HORIZONTALE
						je		Dimensions_Compute_Horizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Dimensions_Compute_Verticale :

						fild	DWord Ptr [dwHeight]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,dwWidth

						cmp		eax,_dwNewWidth
						jl		@F

						mov		eax,DWord Ptr [dwHeight]
						mov		DWord Ptr [_dwNewHeight],eax
						jmp		Dimensions_Compute_Control

@@ :

						fild	DWord Ptr [dwWidth]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,dwWidth
						mov		_dwNewWidth,eax
						jmp		Dimensions_Compute_Control

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Dimensions_Compute_Horizontale :

						fild	DWord Ptr [dwWidth]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,dwHeight

						cmp		eax,_dwNewHeight
						jl		@F

						mov		eax,DWord Ptr [dwWidth]
						mov		DWord Ptr [_dwNewWidth],eax
						jmp		Dimensions_Compute_Control

@@ :

						fild	DWord Ptr [dwHeight]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,dwHeight
						mov		_dwNewHeight,eax

;	=====================================================
;	=== Si l'image est presque carre, il se peut que ===
;	=== l'une des deux coordonnes soit fausse        ===
;	=====================================================

Dimensions_Compute_Control :

;	=======================================================================
;	=== Exemple : Largeur = 768 et Hauteur = 766 => Ratio = 0.997395833 ===
;	=== Le ratio est proche de 1                                        ===
;	=== Dans ce cas, il faut prendre la plus petite dimension entre la  ===
;	=== largeur et la hauteur de la zone client                         ===
;	=======================================================================

;	=============================================================================
;	=== Pour dterminer si le ratio est de 1, je propose la mthode suivante  ===
;	=== Diviser la largeur par 10 puis la multiplier  nouveau par 10         ===
;	=== Faire la mme chose avec la hauteur                                   ===
;	=== Dans le cas prcdent, nous aurions une largeur de 760 et une hauteur ===
;	=== de 760, les deux tant identiques, le ratio est de 1.                 ===
;	=============================================================================

;	=======================================
;	=== Calcul de la largeur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth
						mov		ebx,10
						div		bx

						lea		eax,[eax+4*eax]
						shl		eax,1

						mov		ecx,eax

;	=======================================
;	=== Calcul de la hauteur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
						mov		ebx,10
						div		bx

						lea		eax,[eax+4*eax]
						shl		eax,1

;	====================================================
;	=== Comparaison des deux dimmensions correctives ===
;	====================================================

						sub		eax,ecx						; Si le rsultat est  0
						jnz		Dimensions_Compute_Continue	; Le ration est de 1

;	===============================================================
;	=== Prendre la dimension la plus petite entre la largeur et ===
;	=== la hauteur de la zone client                            ===
;	===============================================================

						mov		eax,DWord Ptr [dwWidth]
						mov		edx,DWord Ptr [dwHeight]

						cmp		eax,edx
						cmovge	eax,edx

						mov		DWord Ptr [_dwLower],eax

						mov		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth

						cmp		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
						jg		Dimensions_Compute_AdjustHorizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Dimensions_Compute_AdjustVerticale :

						fild	DWord Ptr [_dwLower]
						fmul	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewWidth]

						mov		eax,DWord Ptr [_dwLower]
						mov		DWord Ptr [_dwNewHeight],eax

						jmp		Dimensions_Compute_Continue

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Dimensions_Compute_AdjustHorizontale :

						fild	DWord Ptr [_dwLower]
						fdiv	QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio

						fist	DWord Ptr [_dwNewHeight]

						mov		eax,DWord Ptr [_dwLower]
						mov		DWord Ptr [_dwNewWidth],eax

Dimensions_Compute_Continue :

						mov		eax,DWord Ptr [_dwNewWidth]
						mov		edx,DWord Ptr [_dwNewHeight]

						ret
Dimensions_Compute		ENDP

;	========================================================================================================================

Window_Resize			PROC	USES EBX EDI ESI,hWnd:HWND,dwWidth:DWord,dwHeight:DWord
						LOCAL	_rc1:RECT
						LOCAL	_rc2:RECT
						LOCAL	_dwWindowWidth:DWord
						LOCAL	_dwWindowHeight:DWord
						LOCAL	_dwHaut:DWord
						LOCAL	_dwGauche:DWord
						LOCAL	_dwDroite:DWord
						LOCAL	_dwBas:DWord
						LOCAL	_dwNewHeight:DWord
						LOCAL	_dwNewWidth:DWord
						LOCAL	_dwX:DWord
						LOCAL	_dwY:DWord

						INVOKE	GetWindowRect,hWnd,ADDR _rc1

						mov		eax,_rc1.right
						sub		eax,_rc1.left
						mov		_dwWindowWidth,eax

						mov		eax,_rc1.bottom
						sub		eax,_rc1.top
						mov		_dwWindowHeight,eax

						INVOKE	GetClientRect,hWnd,ADDR _rc2

						INVOKE	ClientToScreen,hWnd,ADDR _rc2

						mov		eax,_rc2.top
						sub		eax,_rc1.top
						mov		_dwHaut,eax

						mov		eax,_rc2.left
						sub		eax,_rc1.left
						mov		_dwGauche,eax

						INVOKE	ClientToScreen,hWnd,ADDR _rc2.right

						mov		eax,_rc1.right
						sub		eax,_rc2.right
						mov		_dwDroite,eax

						mov		eax,_rc1.bottom
						sub		eax,_rc2.bottom
						mov		_dwBas,eax

						mov		eax,_dwHaut
						add		eax,_dwBas
						add		eax,dwHeight
						mov		_dwNewHeight,eax

						mov		eax,_dwGauche
						add		eax,_dwDroite
						add		eax,dwWidth
						mov		_dwNewWidth,eax

						INVOKE	SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR _rc1,0

						mov		eax,_rc1.right
						sub		eax,_rc1.left
						sub		eax,_dwNewWidth
						shr		eax,1
						add		eax,_rc1.left
						mov		_dwX,eax

						mov		eax,_rc1.bottom
						sub		eax,_rc1.top
						sub		eax,_dwNewHeight
						shr		eax,1
						add		eax,_rc1.top
						mov		_dwY,eax

						INVOKE	MoveWindow,hWnd,_dwX,_dwY,_dwNewWidth,_dwNewHeight,TRUE

						ret
Window_Resize			ENDP

;	========================================================================================================================
