;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================

;	Attention, il est recommand de faire une copiedu fichier avant d'appeler cette fonction
;	car si le contenu du buffer est modifi, le contenu du fichier sur le disque l'est galement.
;	Il faudrait crire une fonction "File_SafeLoadEntire" qui commencerait par copier le fichier
;	 traiter dans un fichier temporaire et passerait ensuite ce nom de fichier  la fonction "File_LoadEntire".

File_LoadEntire				PROC	USES EBX EDI ESI,__lpszFileToLoad:LPSTR,__lpOriginalFile:Ptr HANDLE,__lpFileMappingObject:Ptr HANDLE
							LOCAL	_hOriginalFile:HANDLE
							LOCAL	_hFileMappingObject:HANDLE

							mov		eax,__lpFileMappingObject

							test	eax,eax
							jz		@Error

							mov		eax,__lpOriginalFile

							test	eax,eax
							jz		@Error

							mov		eax,__lpszFileToLoad

							test	eax,eax
							jz		@Error

							INVOKE	PathFileExists,eax

							test	eax,eax
							jz		@Error

							INVOKE	CreateFile,__lpszFileToLoad,GENERIC_READ or GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		_hOriginalFile,eax

							mov		edx,__lpOriginalFile
							mov		[edx],eax

							INVOKE	CreateFileMapping,_hOriginalFile,NULL,PAGE_READWRITE,0,0,NULL

							test	eax,eax
							jz		@Error_1

							mov		_hFileMappingObject,eax

							mov		edx,__lpFileMappingObject
							mov		[edx],eax

							INVOKE	MapViewOfFile,_hFileMappingObject,FILE_MAP_ALL_ACCESS,0,0,0

							test	eax,eax
							jnz		@Exit

							INVOKE	CloseHandle,_hFileMappingObject

@Error_1 :

							INVOKE	CloseHandle,_hOriginalFile

@Error :

							xor		eax,eax

@Exit :

							ret
File_LoadEntire				ENDP

;	================================================================================

File_Unload					PROC	USES EBX EDI ESI,__lpBuffer:LPBYTE,__hOriginalFile:HANDLE,__hFileMappingObject:HANDLE

							INVOKE	UnmapViewOfFile,__lpBuffer

							INVOKE	CloseHandle,__hFileMappingObject
							INVOKE	CloseHandle,__hOriginalFile

							ret
File_Unload					ENDP

;	================================================================================

cbBrowse				PROC	__hWnd:DWORD,__uMsg:DWORD,__lParam:DWORD,__lpData:DWORD

						INVOKE	SetWindowText,__hWnd,__lpData

						ret
cbBrowse				ENDP

;	================================================================================

BrowseForFolder			PROC	__hParent:DWORD,__lpBuffer:DWORD,__lpszTitle:DWORD,__lpString:DWORD
						LOCAL	_lpIDList:DWORD
						LOCAL	_bi:BROWSEINFO

	; ------------------------------------------------------
	; hParent  = parent window handle
	; lpBuffer = 260 byte buffer to receive path
	; lpTitle  = zero terminated string with dialog title
	; lpString = zero terminated string for secondary text
	; ------------------------------------------------------

						lea		edx,_bi

						mov		eax,__hParent							; parent handle
						mov		(BROWSEINFO Ptr [edx]).hwndOwner,eax
						mov		eax,__lpString							; secondary text
						mov		(BROWSEINFO Ptr [edx]).lpszTitle,eax
						mov		(BROWSEINFO Ptr [edx]).ulFlags,BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN or BIF_NEWDIALOGSTYLE or BIF_STATUSTEXT or BIF_USENEWUI or BIF_VALIDATE
						mov		(BROWSEINFO Ptr [edx]).lpfn,OFFSET cbBrowse
						mov		eax,__lpszTitle							; main title
						mov		(BROWSEINFO Ptr [edx]).lParam,eax
						xor		eax,eax
						mov		(BROWSEINFO Ptr [edx]).pidlRoot,eax
						mov		(BROWSEINFO Ptr [edx]).pszDisplayName,eax
						mov		(BROWSEINFO Ptr [edx]).iImage,eax

						INVOKE	SHBrowseForFolder,edx

						mov		_lpIDList,eax
						push	eax

						.IF	eax != 0
							INVOKE	SHGetPathFromIDList,eax,__lpBuffer
						.ENDIF

@@ :

						 INVOKE	CoTaskMemFree,_lpIDList

						pop		eax
						ret
BrowseForFolder			ENDP

;	================================================================================

File_Write				PROC	USES EBX EDI ESI,__hFile:HANDLE,__lpBuffer:LPBYTE,__dwBufferLength:DWord
						LOCAL	_dwNumberOfBytesWritten:DWord

						mov		_dwNumberOfBytesWritten,0

						INVOKE	WriteFile,__hFile,__lpBuffer,__dwBufferLength,ADDR _dwNumberOfBytesWritten,NULL	

						test	eax,eax
						jz		@Exit

						mov		eax,_dwNumberOfBytesWritten
						sub		eax,__dwBufferLength
						jnz		@Error

						mov		eax,TRUE
						jmp		@Exit

@Error :

						xor		eax,eax

@Exit :

						ret
File_Write				ENDP

;	================================================================================
