; --------------------------------------------------------------------------------------------------------------------------------------
							.Data?
; --------------------------------------------------------------------------------------------------------------------------------------

gdiplusStartupInput			GdiplusStartupInput	<>

gdiplusToken				DWord				?

; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

							ALIGN	4

; --------------------------------------------------------------------------------------------------------------------------------------

GDIPLUS_Init				PROC	USES EBX EDI ESI

							INVOKE	RtlZeroMemory,ADDR gdiplusStartupInput,SIZEOF GdiplusStartupInput

							mov		gdiplusStartupInput.GdiplusVersion, 1

							INVOKE	GdiplusStartup,ADDR gdiplusToken,ADDR gdiplusStartupInput,NULL

							ret
GDIPLUS_Init				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

GDIPlus_Exit				PROC	USES EAX EBX ECX EDI ESI

							INVOKE	GdiplusShutdown,gdiplusToken

							ret
GDIPlus_Exit				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

;	Fonction crite le 6 septembre 2006 par Philippe RIO
;	Modifie le 12/09/2006 pour permettre l'utilisation de "BitmapFromFile" en cas d'chec de la part de GDI+

;	Cette fonction effectue la lecture d'un fichier image et renvoie un pointeur sur l'image charge
;	Il ne fournie aucun handle sur un objet de type HBITMAP
;	Le nom complet du fichier est recopi dans la structure IMAGE_INFOS
;	Le sens de l'image et le ratio W/H ou H/W est galement initialis

;	Au retour, EAX = Pointeur sur un objet de type IMAGE_INFOS

;	La fonction essaie de lire le fichier en utilisant GDI+
;	En cas d'echec, elle essaie alors avec la fonction : "BitmapFromFile"
;	de la bibliothque MASM32.

; --------------------------------------------------------------------------------------------------------------------------------------

GDIPlus_LoadImageFromFile	PROC	USES EBX EDI ESI,__lpszFileName:LPSTR
							LOCAL	_hBitmap:HBITMAP
							LOCAL	_hDC:HDC
							LOCAL	_dwTotalDatasSize:DWord
							LOCAL	_lpImage:Ptr IMAGE_INFOS
							LOCAL	_TmpImageInfos:IMAGE_INFOS
							LOCAL	_lpNewImageBits:LPBYTE
							LOCAL	_Bitmap:BITMAP
							LOCAL	_szTmp[256]:Byte

							mov		DWord Ptr _dwTotalDatasSize,0

;	**************************************
;	*** Vrification du nom du fichier ***
;	**************************************

							mov		eax,DWord Ptr __lpszFileName

							test	eax,eax
							jz		@Exit										; Le pointeur doit tre valide ( <> NULL)

							INVOKE	StrLen,eax

							test	eax,eax
							jz		@Exit										; Le nom du fichier doit comporter au moins un caractre

							INVOKE	PathFileExists,__lpszFileName

							test	eax,eax
							jz		@Exit										; Le fichier doit exister

							INVOKE	BitmapFromFile,__lpszFileName				; Charger l'image

							test	eax,eax
							jz		@Error										; Cration du bitmap impossible

							mov		DWord Ptr _hBitmap,eax

							test	eax,eax
							jz		@Error										; Chargement de l'image impossible

;	****************************************************************************************
;	*** Charger un bloc de mmoire capable de tenir toutes les infos relatives  l'image ***
;	****************************************************************************************

							lea		edi,_TmpImageInfos

;	============================================================
;	=== Obtenir les informations relatives  l'image charge ===
;	============================================================

							INVOKE	GetObject,_hBitmap,SIZEOF BITMAP,ADDR _Bitmap 

;	=================================================
;	=== Initialiser la structure BITMAPINFOHEADER ===
;	=================================================

							mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biSize,SIZEOF BITMAPINFOHEADER
							mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biPlanes,1
							mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biCompression,BI_RGB

							push	DWord Ptr _Bitmap.bmWidth
							pop		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth

							push	DWord Ptr _Bitmap.bmHeight
							pop		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight

							mov		ax,Word Ptr _Bitmap.bmBitsPixel
							mov		Word Ptr (IMAGE_INFOS Ptr [edi]).Image.biBitCount,ax

;	=====================================================================
;	=== Calculer le rapport entre la largeur et la hauteur de l'image ===
;	=====================================================================

							mov		eax,DWord Ptr _Bitmap.bmWidth

							cmp		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
							jg		@Horizontale

							push	IMAGE_VERTICALE

							fild	DWord Ptr _Bitmap.bmWidth
							fidiv	DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight

							jmp		@Continue

@Horizontale :

							push	IMAGE_HORIZONTALE

							fild	DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight
							fidiv	DWord Ptr _Bitmap.bmWidth

@Continue :

							fst		QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio
							pop		(IMAGE_INFOS Ptr [edi]).dwImageSens

							INVOKE	GetDC,NULL								; Prendre un DC sur l'cran

							test	eax,eax
							jz		@Error

							mov		DWord Ptr _hDC,eax
							mov		esi,eax									; ESI = hDC

;	=============================================
;	=== Obtenir les infos relatives  l'image ===
;	=============================================

							INVOKE	GetDIBits,esi,_hBitmap,0,_Bitmap.bmHeight,NULL,ADDR (IMAGE_INFOS Ptr [edi]).Image,DIB_RGB_COLORS

							test	eax,eax
							jz		@Error_2

;	======================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de l'image originale ===
;	======================================================================================

							mov		eax,SIZEOF IMAGE_INFOS
							add		eax,DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biSizeImage
							mov		DWord Ptr _dwTotalDatasSize,eax

							INVOKE	Memory_Alloc,eax

							test	eax,eax
							jz		@Error_2

							push	esi
							push	eax
							push	eax

							mov		DWord Ptr _lpImage,eax
							add		eax,SIZEOF IMAGE_INFOS
							mov		DWord Ptr _lpNewImageBits,eax
							mov		esi,edi

							pop		edi

							mov		ecx,SIZEOF IMAGE_INFOS
							rep		movsb

							pop		edi

							mov		eax,DWord Ptr _lpNewImageBits
							mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).lpImageBits,eax

							pop		esi

;	===========================================
;	=== Obtenir les bits de l'image charge ===
;	===========================================

							INVOKE	GetDIBits,esi,_hBitmap,0,_Bitmap.bmHeight,(IMAGE_INFOS Ptr [edi]).lpImageBits,ADDR (IMAGE_INFOS Ptr [edi]).Image,DIB_RGB_COLORS

							test	eax,eax
							jz		@Error_3

							INVOKE	DeleteObject,_hBitmap

							INVOKE	ReleaseDC,NULL,_hDC

							mov		(IMAGE_INFOS Ptr [edi]).dwImageData,DATA_IMAGES

							mov		eax,DWord Ptr _dwTotalDatasSize
							mov		(IMAGE_INFOS Ptr [edi]).dwTotalDatasSize,eax

@End :

							mov		eax,DWord Ptr _lpImage
							jmp		@Exit

@Error_3 :

							INVOKE	Memory_Free,_lpImage

@Error_2 :

							INVOKE	ReleaseDC,NULL,_hDC

@Error :

							mov		(IMAGE_INFOS Ptr [edi]).dwImageData,DATA_UNKNOWN

							xor		eax,eax

@Exit :

							ret
GDIPlus_LoadImageFromFile	ENDP

;	================================================================================

GDIPlus_QuickLoadImageFile	PROC	USES EBX EDI ESI,__lpszFileName:LPSTR

							INVOKE	BitmapFromFile,__lpszFileName

@Exit :

							ret
GDIPlus_QuickLoadImageFile	ENDP

;	================================================================================

;	================================================================================

GDIPlus_CanILoadThisFile	PROC	USES EBX EDI ESI,__lpszFileName:LPSTR

							INVOKE	BitmapFromFile,__lpszFileName

							test	eax,eax
							jz		@Exit

							INVOKE	DeleteObject,eax

							mov		eax,TRUE

@Exit :

							ret
GDIPlus_CanILoadThisFile	ENDP

;	================================================================================

